;**********************************************************************
;    Filename:	calen.asm 
;    Date:          	2006/1/1
;    File Version:
;**********************************************************************

	list      		p=16F88			 ; list directive to define processor
	#include		 <p16F88.inc>		 ; processor specific variable definitions

	__CONFIG   _CONFIG1,  _CP_OFF & _WDT_OFF & _PWRTE_ON & _INTRC_IO & _LVP_OFF & _MCLR_OFF 

;***** VARIABLE DEFINITIONS
w_temp			EQU     0x20			 ; variable used for context saving 
status_temp		EQU     0x21			 ; variable used for context saving

wait_data		EQU	0x30		;wait data ram
taihi			EQU	0x31		;taihi data
nengou			EQU	0x32		;nengou 
hizuke			EQU	0x33		;hizuke
tuki				EQU	0x34		;tuki

sagyou			EQU	0x38		;sagyou
wait_data_2		EQU	0x39		;wait data 2
key_data			EQU	0x3a		;key data ram
									;key_data,0  RA4 ([H]:nomal-[L]:set)
									;key_data,1  RA5 ([H]:data-[L]:nengou)
									;key_data,2  RA6 (hizuke up)
									;key_data,3  RA7 (tuki up)
									;key_data,4  RB7 (date up)

key_input		EQU	0x3b		;key input ram
									;key_input,0  RA4 ([H]:nomal-[L]:set)
									;key_input,1  RA5 ([H]:data-[L]:nengou)
									;key_input,2  RA6 (hizuke up)
									;key_input,3  RA7 (tuki up)
									;key_input,4  RB7 (date up)
key_cnt0		EQU	0x3c		;key_input2 repeat count
key_cnt1		EQU	0x3d		;key_input3 repeat count
sagyou2			EQU	0x3e		;sagyou2

hyouji1			EQU	0x40		;hyouji1
hyouji2			EQU	0x41		;hyouji2
hyouji3			EQU	0x42		;hyouji3
hyouji4			EQU	0x43		;hyouji4


tm0_setdata		EQU	0x63		;FFH-63H=156 156*128=19.968msec

;**********************************************************************
		ORG     		0x000             ; processor reset vector
  		goto    		main              ; go to beginning of program

;----------------------------------------------------------------------------------
		ORG     		0x004             ; interrupt vector location
		movwf   	w_temp            ; save off current W register contents
		movf		STATUS,w          ; move status register into W register
		movwf		status_temp       ; save off contents of STATUS register

		;---------------------------------	
		bcf			INTCON,TMR0IF
		movlw		tm0_setdata
		movwf		TMR0


next_int
		movf    		status_temp,w     ; retrieve copy of STATUS register
		movwf		STATUS            ; restore pre-isr STATUS register contents
		swapf   		w_temp,f
		swapf  		 w_temp,w          ; restore pre-isr W register contents
		retfie                    ; return from interrupt
;---------------------------------------------------------------------------------------
main
		call			osc_set
		call			port_set
		call			ad_set
		
		movlw		0ffh
		movwf		PORTA
		movlw		0ffh
		movwf		PORTB

		call			timer0_set

		movlw		06h
		movwf		nengou
		movlw		01h
		movwf		hizuke
		movwf		tuki
		
;--------------------------------------
main_loop
		movlw		0ffh				;key input clear
		movwf		key_input
		btfss		PORTA,6		;RA6 check
		bcf			key_input,2		;RA6 input ari
		btfss		PORTA,7		;RA7 check
		bcf			key_input,3		;RA7 input ari
		btfss		PORTB,7		;RB7 check
		bcf			key_input,4		;RB7 input ari	
		;--------------------------------- LED disp
		btfsc		PORTA,5
		goto		disp_next2
		;--------------------------------- nengou 
		movlw		0ah
		call			henkan1
		movwf		hyouji1
		movlw		0ah
		call			henkan1
		movwf		hyouji2
		movlw		0fh
		andwf		nengou,0
		call			henkan1
		movwf		hyouji4
		swapf		nengou,0
		movwf		sagyou2
		movlw		0fh
		andwf		sagyou2,0
		call			henkan1
		movwf		hyouji3
		goto		disp_hyouji
		;--------------------------------- date
disp_next2
		movlw		0fh
		andwf		hizuke,0
		call			henkan1
		movwf		hyouji4
		swapf		hizuke,0
		movwf		sagyou2
		movlw		0fh
		andwf		sagyou2,0
		btfsc		STATUS,2
		movlw		0ah
		call			henkan1
		movwf		hyouji3

		movlw		0fh
		andwf		tuki,0
		call			henkan1
		movwf		hyouji2
		swapf		tuki,0
		movwf		sagyou2
		movlw		0fh
		andwf		sagyou2,0
		btfsc		STATUS,2
		movlw		0ah
		call			henkan1
		movwf		hyouji1		
		;--------------------------------- hyouji
disp_hyouji
		call			clear_sel
		bcf			PORTA,0
		bsf			hyouji1,7
		movf		hyouji1,0
		movwf		PORTB
		call			wait_10
		call			clear_sel
		bcf			PORTA,1
		bsf			hyouji2,7
		movf		hyouji2,0
		movwf		PORTB
		call			wait_10
		call			clear_sel
		bcf			PORTA,2
		bsf			hyouji3,7
		movf		hyouji3,0
		movwf		PORTB
		call			wait_10
		call			clear_sel
		bcf			PORTA,3
		bsf			hyouji4,7
		movf		hyouji4,0
		movwf		PORTB
		call			wait_10
		call			clear_sel
disp_end
		;----------------------------------RA6 sw check
		btfss		PORTA,6		;RA6 sw key check
		goto		sw1_next
		bsf			key_data,2		;RA6 sw key off
		goto		sw1_end
sw1_next
		btfsc		key_input,2		;RA6 sw input check
		goto		sw1_end
		;------------------------
		btfsc		PORTA,4
		goto		sw1_end
		;------------------------ 
		btfss		key_data,2		;RA6 sw on check
		goto		sw1_rep
		bcf			key_data,2		;RA6 sw on
		;------------------------
		call			key_cnt_set
sw1_next_r
		;------------------------
		btfsc		PORTA,5
		goto		sw1_next2
		call			nengou_up
		goto		sw_end
		;-------------------------
sw1_next2
		call			hizuke_up
		goto		sw_end
		;------------------------
sw1_rep
		decfsz		key_cnt0,1
		goto		sw1_end
		call			key_cnt_set_r
		goto		sw1_next_r

sw1_end
		;------------------------

		;----------------------------------RA7 sw check
		btfss		PORTA,7		;RA7 sw key check
		goto		sw2_next
		bsf			key_data,3		;RA7 sw key off
		goto		sw2_end
sw2_next
		btfsc		key_input,3		;RA7 sw input check
		goto		sw2_end
		;------------------------
		btfsc		PORTA,4
		goto		sw2_end
		;------------------------ 
		btfss		key_data,3		;RA7 sw on check
		goto		sw2_rep
		bcf			key_data,3		;RA7 sw on
		;------------------------
		call			key_cnt_set
sw2_next_r

		;------------------------
		btfsc		PORTA,5
		goto		sw2_next2
		goto		sw_end
		;-------------------------
sw2_next2
		call			tuki_up
		goto		sw_end
		;------------------------
sw2_rep
		decfsz		key_cnt1,1
		goto		sw2_end
		call			key_cnt_set_r
		goto		sw2_next_r

sw2_end
		;------------------------

		;----------------------------------RB7 input check
		btfss		PORTB,7		;RB7 input check
		goto		sw3_next
		bsf			key_data,4		;RB7 input nashi
		goto		sw3_end
sw3_next
		btfsc		key_input,4		;RB7 input check
		goto		sw3_end
		;------------------------
		btfss		PORTA,4
		goto		sw3_end
		;------------------------ 
		btfss		key_data,4		;RB7 input check
		goto		sw3_end
		bcf			key_data,4		;RB7 input ari		
		;------------------------		
		call			date_up
sw3_end
		;------------------------



sw_end
	
;---------------------------------------
		goto		main_loop
;---------------------------------------
nengou_up
		movf		nengou,0
		call			inc_nengou
		movwf		nengou
		return
;---------------------------------------
tuki_up
		movf		tuki,0
		call			inc_tuki
		andlw		7fh
		movwf		tuki
		movlw		01h
		movwf		hizuke
		return
;---------------------------------------
hizuke_up
		movlw		02h
		subwf		tuki,0
		btfsc		STATUS,2
		goto		hizuke_2gatu
		movlw		04h
		subwf		tuki,0
		btfsc		STATUS,2
		goto		hizuke_30
		movlw		06h
		subwf		tuki,0
		btfsc		STATUS,2
		goto		hizuke_30
		movlw		09h
		subwf		tuki,0
		btfsc		STATUS,2
		goto		hizuke_30
		movlw		11h
		subwf		tuki,0
		btfsc		STATUS,2
		goto		hizuke_30
hizuke_31
		movf		hizuke,0
		call			inc_hizuke31
		andlw		7fh
		movwf		hizuke
		return
hizuke_30
		movf		hizuke,0
		call			inc_hizuke30
		andlw		7fh
		movwf		hizuke
		return
hizuke_2gatu
		movf		nengou,0
		call			han_nengou
		andlw		0ffh
		btfsc		STATUS,2
		goto		hizuke_28
hizuke_29
		movf		hizuke,0
		call			inc_hizuke29
		andlw		7fh
		movwf		hizuke
		return
hizuke_28
		movf		hizuke,0
		call			inc_hizuke28
		andlw		7fh
		movwf		hizuke
		return

;---------------------------------------
date_up
		movlw		02h
		subwf		tuki,0
		btfsc		STATUS,2
		goto		date_up_2gatu
		movlw		04h
		subwf		tuki,0
		btfsc		STATUS,2
		goto		date_up_30
		movlw		06h
		subwf		tuki,0
		btfsc		STATUS,2
		goto		date_up_30
		movlw		09h
		subwf		tuki,0
		btfsc		STATUS,2
		goto		date_up_30
		movlw		11h
		subwf		tuki,0
		btfsc		STATUS,2
		goto		date_up_30
date_up_31
		movf		hizuke,0
		call			inc_hizuke31
date_up_311
		movwf		sagyou2
		btfsc		sagyou2,7
		goto		date_up_312
		andlw		7fh
		movwf		hizuke
		return
date_up_312
		andlw		7fh
		movwf		hizuke
		call			mon_up
		return
date_up_30
		movf		hizuke,0
		call			inc_hizuke30
		goto		date_up_311
date_up_2gatu
		movf		nengou,0
		call			han_nengou
		andlw		0ffh
		btfsc		STATUS,2
		goto		date_up_28
date_up_29
		movf		hizuke,0
		call			inc_hizuke29
		goto		date_up_311
date_up_28
		movf		hizuke,0
		call			inc_hizuke28
		goto		date_up_311
		
;---------------------------------------
mon_up
		movf		tuki,0
		call			inc_tuki
		movwf		sagyou2
		btfsc		sagyou2,7
		goto		mon_up_2
		andlw		7fh
		movwf		tuki
		return		
mon_up_2
		andlw		7fh
		movwf		tuki
		call			nengou_up
		return

;-------------------------------------------------------------------------------
wait_20
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		return
;-------------------------------------------------------------------------------
wait_10
		movlw		5h
		movwf		wait_data_2
wait_10_2
		call			wait_1
		decfsz		wait_data_2,1
		goto		wait_10_2
		return

wait_0
		movlw		0ffh
		movwf		wait_data
		goto		wait_2
wait_1		
		movlw		0ffh
		movwf		wait_data
wait_2
		nop
		decfsz		wait_data,1
		goto		wait_2
		return
;------------------------------------------------------------------------------
clear_sel
		bsf			PORTA,0
		nop
		bsf			PORTA,1
		nop
		bsf			PORTA,2
		nop
		bsf			PORTA,3
		nop
		return		
;------------------------------------------------------------------------------
key_cnt_set_r
		movlw		0ah
		goto		key_cnt_set2
key_cnt_set
		movlw		030h
key_cnt_set2
		movwf		key_cnt0
		movwf		key_cnt1
		return
;------------------------------------------------------------------------------
henkan1
		movwf		taihi
		movlw		low(henkan1_table)
		addwf		taihi,1
		movlw		high(henkan1_table)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
henkan1_table	;-----------
		retlw		40h			;0
		retlw		79h			;1
		retlw		24h			;2
		retlw		30h			;3
		retlw		19h			;4
		retlw		12h			;5
		retlw		02h			;6
		retlw		58h			;7
		retlw		00h			;8
		retlw		10h			;9
		retlw		7fh			;a
		retlw		7fh			;b
		retlw		7fh			;c
		retlw		7fh			;d
		retlw		7fh			;e
		retlw		7fh			;f
;------------------------------------------------------------------------------
inc_hizuke31
		movwf		taihi
		movlw		low(inc_table31)
		addwf		taihi,1
		movlw		high(inc_table31)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
inc_table31	;-----------
		retlw		01h			;00
		retlw		02h			;01
		retlw		03h			;02
		retlw		04h			;03
		retlw		05h			;04
		retlw		06h			;05
		retlw		07h			;06
		retlw		08h			;07
		retlw		09h			;08
		retlw		10h			;09
		retlw		10h			;0a
		retlw		10h			;0b
		retlw		10h			;0c
		retlw		10h			;0d
		retlw		10h			;0e
		retlw		10h			;0f
		retlw		11h			;10
		retlw		12h			;11
		retlw		13h			;12
		retlw		14h			;13
		retlw		15h			;14
		retlw		16h			;15
		retlw		17h			;16
		retlw		18h			;17
		retlw		19h			;18
		retlw		20h			;19
		retlw		20h			;1a
		retlw		20h			;1b
		retlw		20h			;1c
		retlw		20h			;1d
		retlw		20h			;1e
		retlw		20h			;1f
		retlw		21h			;20
		retlw		22h			;21
		retlw		23h			;22
		retlw		24h			;23
		retlw		25h			;24
		retlw		26h			;25
		retlw		27h			;26
		retlw		28h			;27
		retlw		29h			;28
		retlw		30h			;29
		retlw		30h			;2a
		retlw		30h			;2b
		retlw		30h			;2c
		retlw		30h			;2d
		retlw		30h			;2e
		retlw		30h			;2f
		retlw		31h			;30
		retlw		81h			;31

;------------------------------------------------------------------------------
inc_hizuke30
		movwf		taihi
		movlw		low(inc_table30)
		addwf		taihi,1
		movlw		high(inc_table30)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
inc_table30	;-----------
		retlw		01h			;00
		retlw		02h			;01
		retlw		03h			;02
		retlw		04h			;03
		retlw		05h			;04
		retlw		06h			;05
		retlw		07h			;06
		retlw		08h			;07
		retlw		09h			;08
		retlw		10h			;09
		retlw		10h			;0a
		retlw		10h			;0b
		retlw		10h			;0c
		retlw		10h			;0d
		retlw		10h			;0e
		retlw		10h			;0f
		retlw		11h			;10
		retlw		12h			;11
		retlw		13h			;12
		retlw		14h			;13
		retlw		15h			;14
		retlw		16h			;15
		retlw		17h			;16
		retlw		18h			;17
		retlw		19h			;18
		retlw		20h			;19
		retlw		20h			;1a
		retlw		20h			;1b
		retlw		20h			;1c
		retlw		20h			;1d
		retlw		20h			;1e
		retlw		20h			;1f
		retlw		21h			;20
		retlw		22h			;21
		retlw		23h			;22
		retlw		24h			;23
		retlw		25h			;24
		retlw		26h			;25
		retlw		27h			;26
		retlw		28h			;27
		retlw		29h			;28
		retlw		30h			;29
		retlw		30h			;2a
		retlw		30h			;2b
		retlw		30h			;2c
		retlw		30h			;2d
		retlw		30h			;2e
		retlw		30h			;2f
		retlw		81h			;30
		retlw		81h			;31
	
;------------------------------------------------------------------------------
inc_hizuke29
		movwf		taihi
		movlw		low(inc_table29)
		addwf		taihi,1
		movlw		high(inc_table29)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
inc_table29	;-----------
		retlw		01h			;00
		retlw		02h			;01
		retlw		03h			;02
		retlw		04h			;03
		retlw		05h			;04
		retlw		06h			;05
		retlw		07h			;06
		retlw		08h			;07
		retlw		09h			;08
		retlw		10h			;09
		retlw		10h			;0a
		retlw		10h			;0b
		retlw		10h			;0c
		retlw		10h			;0d
		retlw		10h			;0e
		retlw		10h			;0f
		retlw		11h			;10
		retlw		12h			;11
		retlw		13h			;12
		retlw		14h			;13
		retlw		15h			;14
		retlw		16h			;15
		retlw		17h			;16
		retlw		18h			;17
		retlw		19h			;18
		retlw		20h			;19
		retlw		20h			;1a
		retlw		20h			;1b
		retlw		20h			;1c
		retlw		20h			;1d
		retlw		20h			;1e
		retlw		20h			;1f
		retlw		21h			;20
		retlw		22h			;21
		retlw		23h			;22
		retlw		24h			;23
		retlw		25h			;24
		retlw		26h			;25
		retlw		27h			;26
		retlw		28h			;27
		retlw		29h			;28
		retlw		81h			;29
		retlw		81h			;2a
		retlw		81h			;2b
		retlw		81h			;2c
		retlw		81h			;2d
		retlw		81h			;2e
		retlw		81h			;2f
		retlw		81h			;30
		retlw		81h			;31
;------------------------------------------------------------------------------
inc_hizuke28
		movwf		taihi
		movlw		low(inc_table28)
		addwf		taihi,1
		movlw		high(inc_table28)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
inc_table28	;-----------
		retlw		01h			;00
		retlw		02h			;01
		retlw		03h			;02
		retlw		04h			;03
		retlw		05h			;04
		retlw		06h			;05
		retlw		07h			;06
		retlw		08h			;07
		retlw		09h			;08
		retlw		10h			;09
		retlw		10h			;0a
		retlw		10h			;0b
		retlw		10h			;0c
		retlw		10h			;0d
		retlw		10h			;0e
		retlw		10h			;0f
		retlw		11h			;10
		retlw		12h			;11
		retlw		13h			;12
		retlw		14h			;13
		retlw		15h			;14
		retlw		16h			;15
		retlw		17h			;16
		retlw		18h			;17
		retlw		19h			;18
		retlw		20h			;19
		retlw		20h			;1a
		retlw		20h			;1b
		retlw		20h			;1c
		retlw		20h			;1d
		retlw		20h			;1e
		retlw		20h			;1f
		retlw		21h			;20
		retlw		22h			;21
		retlw		23h			;22
		retlw		24h			;23
		retlw		25h			;24
		retlw		26h			;25
		retlw		27h			;26
		retlw		28h			;27
		retlw		81h			;28
		retlw		81h			;29
		retlw		81h			;2a
		retlw		81h			;2b
		retlw		81h			;2c
		retlw		81h			;2d
		retlw		81h			;2e
		retlw		81h			;2f
		retlw		81h			;30
		retlw		81h			;31

;------------------------------------------------------------------------------
inc_nengou
		movwf		taihi
		movlw		low(inc_nengou_table)
		addwf		taihi,1
		movlw		high(inc_nengou_table)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
inc_nengou_table	;-----------
		retlw		01h			;00
		retlw		02h			;01
		retlw		03h			;02
		retlw		04h			;03
		retlw		05h			;04
		retlw		06h			;05
		retlw		07h			;06
		retlw		08h			;07
		retlw		09h			;08
		retlw		10h			;09
		retlw		10h			;0a
		retlw		10h			;0b
		retlw		10h			;0c
		retlw		10h			;0d
		retlw		10h			;0e
		retlw		10h			;0f
		retlw		11h			;10
		retlw		12h			;11
		retlw		13h			;12
		retlw		14h			;13
		retlw		15h			;14
		retlw		16h			;15
		retlw		17h			;16
		retlw		18h			;17
		retlw		19h			;18
		retlw		20h			;19
		retlw		20h			;1a
		retlw		20h			;1b
		retlw		20h			;1c
		retlw		20h			;1d
		retlw		20h			;1e
		retlw		20h			;1f
		retlw		21h			;20
		retlw		22h			;21
		retlw		23h			;22
		retlw		24h			;23
		retlw		25h			;24
		retlw		26h			;25
		retlw		27h			;26
		retlw		28h			;27
		retlw		29h			;28
		retlw		30h			;29
		retlw		30h			;2a
		retlw		30h			;2b
		retlw		30h			;2c
		retlw		30h			;2d
		retlw		30h			;2e
		retlw		30h			;2f
		retlw		31h			;30
		retlw		32h			;31
		retlw		33h			;32
		retlw		34h			;33
		retlw		35h			;34
		retlw		36h			;35
		retlw		37h			;36
		retlw		38h			;37
		retlw		39h			;38
		retlw		05h			;39

;------------------------------------------------------------------------------
han_nengou
		movwf		taihi
		movlw		low(han_nengou_table)
		addwf		taihi,1
		movlw		high(han_nengou_table)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
han_nengou_table	;-----------
		retlw		01h			;00
		retlw		00h			;01
		retlw		00h			;02
		retlw		00h			;03
		retlw		01h			;04
		retlw		00h			;05
		retlw		00h			;06
		retlw		00h			;07
		retlw		01h			;08
		retlw		00h			;09
		retlw		00h			;0a
		retlw		00h			;0b
		retlw		00h			;0c
		retlw		00h			;0d
		retlw		00h			;0e
		retlw		00h			;0f
		retlw		00h			;10
		retlw		00h			;11
		retlw		01h			;12
		retlw		00h			;13
		retlw		00h			;14
		retlw		00h			;15
		retlw		01h			;16
		retlw		00h			;17
		retlw		00h			;18
		retlw		00h			;19
		retlw		00h			;1a
		retlw		00h			;1b
		retlw		00h			;1c
		retlw		00h			;1d
		retlw		00h			;1e
		retlw		00h			;1f
		retlw		01h			;20
		retlw		00h			;21
		retlw		00h			;22
		retlw		00h			;23
		retlw		01h			;24
		retlw		00h			;25
		retlw		00h			;26
		retlw		00h			;27
		retlw		01h			;28
		retlw		00h			;29
		retlw		00h			;2a
		retlw		00h			;2b
		retlw		00h			;2c
		retlw		00h			;2d
		retlw		00h			;2e
		retlw		00h			;2f
		retlw		00h			;30
		retlw		00h			;31
		retlw		01h			;32
		retlw		00h			;33
		retlw		00h			;34
		retlw		00h			;35
		retlw		01h			;36
		retlw		00h			;37
		retlw		00h			;38
		retlw		00h			;39
		
;------------------------------------------------------------------------------
inc_tuki
		movwf		taihi
		movlw		low(inc_tuki_table)
		addwf		taihi,1
		movlw		high(inc_tuki_table)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
inc_tuki_table	;-----------
		retlw		01h			;00
		retlw		02h			;01
		retlw		03h			;02
		retlw		04h			;03
		retlw		05h			;04
		retlw		06h			;05
		retlw		07h			;06
		retlw		08h			;07
		retlw		09h			;08
		retlw		10h			;09
		retlw		10h			;0a
		retlw		10h			;0b
		retlw		10h			;0c
		retlw		10h			;0d
		retlw		10h			;0e
		retlw		10h			;0f
		retlw		11h			;10
		retlw		12h			;11
		retlw		81h			;12
;------------------------------------------------------------------------------
banksel_0
		bcf			STATUS,RP0
		nop
		bcf			STATUS,RP1
		nop
		return
banksel_1
		bsf			STATUS,RP0
		nop
		bcf			STATUS,RP1
		nop
		return
banksel_2
		bcf			STATUS,RP0
		nop
		bsf			STATUS,RP1
		nop
		return
banksel_3
		bsf			STATUS,RP0
		nop
		bsf			STATUS,RP1
		nop
		return
;------------------------------------------------------------------------------
osc_set
		call			banksel_1
								;(0)NC
								;(110)IRCF2-IRCF0
								;(0)OSTS
								;(1)IOFS
								;(00)SCS
		movlw		64h
		movwf		OSCCON
		call			banksel_0
		return
;-------------------------------------------------------------------------------
port_set							;RA0,RA1,RA2,RA3(OUT)
								;RA4,RA5,RA6,RA7(IN)
								;RB0,RB1,RB2,RB3,RB4,RB5,RB6(OUT)
								;RB7(IN)
		call			banksel_1
		clrf			TRISA
		bsf			TRISA,4
		nop
		bsf			TRISA,5
		nop
		bsf			TRISA,6
		nop
		bsf			TRISA,7
		nop
		clrf			TRISB
		bsf			TRISB,7
		nop
		call			banksel_0
		return
;------------------------------------------------------------------------------
ad_set
								;(01)ADCS1,ADCS0
								;(000)CHS2,CHS1,CHS0
								;(0)GO/DONE
								;(0)NC
								;(0)ADON
		movlw		40h
		movwf		ADCON0
		call			banksel_1
								;(0)ADFM
								;(1)ADCS2
								;(00)VCFG1,VCFG0
								;(0000)
		movlw		40h
		movwf		ADCON1
								;(0)NC
								;(0000000)ANS6-ANS0
		movlw		00h
		movwf		ANSEL
		call			banksel_0
		return
;------------------------------------------------------------------------------
timer0_set

		call			banksel_1
		movlw		086h		;(1)PORTB NOT PULLUP
								;(0)INTEDG
								;(0)TOCS
								;(0)TOSE
								;(0)PSA
								;(110)1/128
		movwf		OPTION_REG
		call			banksel_0

		movlw		tm0_setdata
		movwf		TMR0
		bcf			INTCON,TMR0IE
		bcf			INTCON,GIE
		return
;-------------------------------------------------------------------------------

		end                     ; directive 'end of program'
